extends Node3D

var mengerdimension = 3
var holelength = 1.0  # set this to 1.01 to make sure the holes go all the way through

func _ready():
	var basebox : CSGBox3D = get_node("CSGBox3D")
	assert (basebox.size == Vector3(1,1,1))
	remove_child(basebox)
	add_child(mengerSponge(basebox, mengerdimension))

	
func mengerSponge(result, n):
	var choles = CSGCombiner3D.new()
	fractal(choles, result, 1.0, Vector3(0,0,0), 1, n)
	choles.operation = CSGShape3D.OPERATION_SUBTRACTION
	result.add_child(choles)
	var choles2 = choles.duplicate()
	choles2.rotation_degrees.y = 90
	result.add_child(choles2)
	var choles3 = choles.duplicate()
	choles3.rotation_degrees.x = 90
	result.add_child(choles3)

	var slice = CSGBox3D.new()
	slice.size = Vector3(10,10,10)
	slice.look_at_from_position(Vector3(0,0,0), Vector3(1,1,-1))
	slice.position = Vector3(1,1,-1).normalized()*5.001
	slice.operation = CSGShape3D.OPERATION_SUBTRACTION
	result.add_child(slice)
	return result

func fractal(choles, lhole, w, lposition, depth, maxDepth):
	w /= 3.0
	var hole = lhole.duplicate()
	hole.size = Vector3(w,w,holelength)
	hole.position = hole.position*w + lposition
	hole.operation = CSGShape3D.OPERATION_UNION
	choles.add_child(hole)
	if depth == maxDepth: 
		return;
	var offsets = [
		Vector3(-w, -w, 0), Vector3(-w, 0.0, 0),
		Vector3(-w, w, 0), Vector3(0.0, w, 0),
		Vector3(w, w, 0), Vector3(w, 0.0, 0),
		Vector3(w, -w, 0), Vector3(0.0, -w, 0)
	];
	for offset in offsets:
		fractal(choles, hole, w, lposition+offset, depth+1, maxDepth)
